com.fasterxml.jackson.databind.deser.std

## Class StringArrayDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<String[]>
    - - com.fasterxml.jackson.databind.deser.std.StringArrayDeserializer

- All Implemented Interfaces:
    ContextualDeserializer, Serializable

      public final class StringArrayDeserializer
      extends StdDeserializer<String[]>
      implements ContextualDeserializer

  Separate implementation for serializing String arrays (instead of using `ObjectArrayDeserializer`. Used if (and only if) no custom value deserializers are used.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JsonDeserializer<String>` | `_elementDeserializer` Value serializer to use, if not the standard one (which is inlined)
    `static StringArrayDeserializer` | `instance`

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `StringArrayDeserializer()`
    `protected` | `StringArrayDeserializer(JsonDeserializer<?> deser)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected String[]` | `_deserializeCustom(JsonParser jp, DeserializationContext ctxt)` Offlined version used when we do not use the default deserialization method.
    `JsonDeserializer<?>` | `createContextual(DeserializationContext ctxt, BeanProperty property)` Contextualization is needed to see whether we can "inline" deserialization of String values, or if we have to use separate value deserializer.
    `String[]` | `deserialize(JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `Object` | `deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, getValueClass, getValueType, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserialize, getDelegatee, getEmptyValue, getKnownPropertyNames, getNullValue, getObjectIdReader, isCachable, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### instance

          public static final StringArrayDeserializer instance

    - #### _elementDeserializer

          protected JsonDeserializer<String> _elementDeserializer

      Value serializer to use, if not the standard one (which is inlined)

  - ### Constructor Detail

    - #### StringArrayDeserializer

          public StringArrayDeserializer()

    - #### StringArrayDeserializer

          protected StringArrayDeserializer(JsonDeserializer<?> deser)

  - ### Method Detail

    - #### deserialize

          public String[] deserialize(JsonParser jp,
                             DeserializationContext ctxt)
                               throws IOException,
                                      JsonProcessingException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<String[]>`
      Parameters:
        `jp` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserializer value
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### _deserializeCustom

          protected final String[] _deserializeCustom(JsonParser jp,
                                    DeserializationContext ctxt)
                                               throws IOException,
                                                      JsonProcessingException

      Offlined version used when we do not use the default deserialization method.
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeWithType

          public Object deserializeWithType(JsonParser jp,
                                   DeserializationContext ctxt,
                                   TypeDeserializer typeDeserializer)
                                     throws IOException,
                                            JsonProcessingException

      Description copied from class: `StdDeserializer`
      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `StdDeserializer<String[]>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### createContextual

          public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                             BeanProperty property)
                                               throws JsonMappingException

      Contextualization is needed to see whether we can "inline" deserialization of String values, or if we have to use separate value deserializer.
      Specified by:
        `createContextual` in interface `ContextualDeserializer`
      Parameters:
        `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
        `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
      Returns:
        Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

Copyright © 2012-2013 FasterXML. All Rights Reserved.